#include "adc.h"
#include "stm32l0xx.h"

#define MaxClockCycle 0x07




void pa1_adc_init(void)
{

	/****Configure gpio pin for adc***/
	/*Enable clock access to GPIOA*/
	RCC->IOPENR |=RCC_IOPENR_IOPAEN;

	/*Set pa4 mode to analog mode*/
	GPIOA->MODER |=GPIO_MODER_MODE1;


	/******Configure the adc module******/
	/*Enable clock access to ADC*/
	RCC->APB2ENR |= RCC_APB2ENR_ADC1EN;

	/*Set sampling time  TO 160.5 ADC clock cycles*/
	ADC1->SMPR |=(MaxClockCycle<<ADC_SMPR_SMP_Pos);


    /*Set Continuous conversion mode*/
	ADC1->CFGR1 |=ADC_CFGR1_CONT;

	/*Set sequencer channel*/
	ADC1->CHSELR |=ADC_CHSELR_CHSEL1;

	/*Set clock to be CLCK/2*/

	ADC1->CFGR2|=ADC_CFGR2_CKMODE_0;

}



void adc_activate(void)
{
	/*Start ADC calibration*/
	ADC1->CR |= ADC_CR_ADCAL;

	/*Enable ADC*/
	ADC1->CR |= ADC_CR_ADEN;

}


void start_conversion(void)
{
	/*Start conversion*/
	ADC1->CR |= ADC_CR_ADSTART;

	/*Clear End-of-Conversion flag*/
 	ADC1->ISR &= ~ADC_ISR_EOC;
}


uint32_t adc_read(void)
{
	/*Wait for conversion completion*/
	while(!(ADC1->ISR & (ADC_ISR_EOC))){}

	/*Read result*/
	return (ADC1->DR);
}
