#include "tim.h"

#include "stm32l0xx.h"

#define TIM2_AF 0x02


void tim2_pwm()
	{


	/*Enable clock access to GPIOA*/
	RCC->IOPENR |= RCC_IOPENR_GPIOAEN;
	/*Set PA0 and PA1 to alternate function*/
	GPIOA->MODER|=GPIO_MODER_MODE0_1|GPIO_MODER_MODE1_1;
	GPIOA->MODER&=~(GPIO_MODER_MODE0_0|GPIO_MODER_MODE1_0);
	/*Select which alternate function*/
	GPIOA->AFR[0]|=(TIM2_AF<<0)|(TIM2_AF<<4);

	/**Configure timer 2 in PWM mode */

	RCC->APB1ENR|=RCC_APB1ENR_TIM2EN;
	TIM2->PSC=0;
	TIM2->ARR=100;
	TIM2->CCMR1|=TIM_CCMR1_OC1M_2|TIM_CCMR1_OC1M_1|TIM_CCMR1_OC2M_2|TIM_CCMR1_OC2M_1;
	TIM2->CCER|=TIM_CCER_CC1E|TIM_CCER_CC2E;
	TIM2->CR1|=TIM_CR1_CEN;

	}

void update_duty_cycle(PWM_CH ch, uint16_t duty )
	{
	uint16_t max_duty=TIM2->ARR; /*Limit the Duty cycle to ARR maximum value*/
	if(duty>max_duty){duty=max_duty;}
	switch (ch)
	{
		case CH1: TIM2->CCR1=duty; break;
		case CH2: TIM2->CCR2=duty; break;
		default: break;

	}

	}
